<?PHP
/*
original file name   : mybitskins.lib.php
begin                : December 29 2004
copyright            : (C) 2005 Olivier D. alias ze kat
email                : oliezekat@yahoofr
web					 : www.yahooplus.fr.st

This program is free software; you can redistribute it and/or modify  	
it under the terms of the GNU General Public License as published by  
the Free Software Foundation; either version 2 of the License, or	    	
(at your option) any later version.

AUTHORS:
Olivier D. alias ze kat :	oliezekat@yahoo.fr	since December 29 2004

GLOBAL VARS:
$mYBitSkins[][]			:	Array (x2) which store settings (paths, URLs, templates, strings, etc)

FUNCTIONS AVAILABLES:
mYBS_SetTitles()				:
mYBS_SetTemplates()				:
mYBS_SetPopUpScript()			:
mYBS_SetThumbailsSizes()		:
mYBS_SetPicturesURLs()			:
mYBS_Print() 					:	print HTML source-code from templates and settings of $mYBitSkins
mYBS_File_NameToDisplay()		:
mYBS_Zip_ExtractPreview()		:	NOT FINISH, don't work under Windows server
*/
function mYBS_SetTitles($LanguageCode='en')
	{
	//Configuration de mYBitSkins
	global $mYBitSkins;
	
	if ($LanguageCode == 'fr')
		{
		$mYBitSkins['Titles']['ClickToShowPreview'] = "Cliquez pour voir un aperu du thme";
		$mYBitSkins['Titles']['NoPreviewAvailable']	= "Aperu non disponible";
		$mYBitSkins['Titles']['ZipFile']			= "Thme enregistr au format Zip";
		$mYBitSkins['Titles']['YSZFile']			= "Thme enregistr au format Yahoo! Skin Zip";
		$mYBitSkins['Titles']['YMSFile']			= "Thme enregistr au format Yahoo! Messenger Skin";
		$mYBitSkins['Titles']['ClickToDownload']	= "Tlcharger le thme";
		}
	else if ($LanguageCode == 'en')
		{
		$mYBitSkins['Titles']['ClickToShowPreview'] = "Click to see preview";
		$mYBitSkins['Titles']['NoPreviewAvailable']	= "Preview not available";
		$mYBitSkins['Titles']['ZipFile']			= "Theme save as Zip file";
		$mYBitSkins['Titles']['YSZFile']			= "Theme save as Yahoo! Skin Zip file";
		$mYBitSkins['Titles']['YMSFile']			= "Theme save as Yahoo! Messenger Skin file";
		$mYBitSkins['Titles']['ClickToDownload']	= "Download this theme";
		}
	else
		{
		$mYBitSkins['Titles']['ClickToShowPreview'] = "Click to see preview";
		$mYBitSkins['Titles']['NoPreviewAvailable']	= "Preview not available";
		$mYBitSkins['Titles']['ZipFile']			= "Theme save as Zip file";
		$mYBitSkins['Titles']['YSZFile']			= "Theme save as Yahoo! Skin Zip file";
		$mYBitSkins['Titles']['YMSFile']			= "Theme save as Yahoo! Messenger Skin file";
		$mYBitSkins['Titles']['ClickToDownload']	= "Download this theme";
		}
	}
	
//Set templates for HTML output
function mYBS_SetTemplates($ModelCode='TABLE')
	{
	//Configuration de mYBitSkins
	global $mYBitSkins;
	
	if ($ModelCode == 'LIST')
		{
		$mYBitSkins['Templates']['Begin'] 			= "<ul style=\"list-style-type: none\">\n";
		$mYBitSkins['Templates']['ItemBegin'] 		= "<li>\n";
		$mYBitSkins['Templates']['ThumbailOnClick']	= $mYBitSkins['Preview']['JavaScript']."('%window-name%','".$mYBitSkins['Preview']['Width']."','".$mYBitSkins['Preview']['Height']."');";
		$mYBitSkins['Templates']['Preview'] 		= "<a href=\"%preview-url%\" target=\"%window-name%\" onclick=\"%thumbail-on-click%\"><img src=\"".$mYBitSkins['Pictures']['PreviewIcon']."\" align=\"absmiddle\" border=\"0\" title=\"".$mYBitSkins['Titles']['ClickToShowPreview']."\" vspace=\"1\" /></a>\n";
		$mYBitSkins['Templates']['NoPreview'] 		= "";
		$mYBitSkins['Templates']['Icon'] 			= "<img src=\"%icon-url%\" align=\"absmiddle\" border=\"0\" title=\"%icon-title%\" vspace=\"1\" />\n";
		$mYBitSkins['Templates']['ItemBody'] 		= "<a href=\"%download-url%\" title=\"%download-title%\">%icon-tpl%</a>\n <sup>%preview-tpl%</sup>\n <a href=\"%download-url%\" title=\"%download-title%\">%display-name%</a>\n";
		$mYBitSkins['Templates']['ItemEnd'] 		= "</li>\n";
		$mYBitSkins['Templates']['NewItemsGroup'] 	= "";
		$mYBitSkins['Templates']['End'] 			= "</ul>\n";
		
		$mYBitSkins['Settings']['ItemsByGroup'] = 0;
		}
	else if ($ModelCode == 'TABLE-LISTS')
		{
		$mYBitSkins['Templates']['Begin'] 			= "<table width=\"95%\">\n<tr>\n<td align=\"left\" valign=\"top\">\n<ul style=\"list-style-type: none\">\n";
		$mYBitSkins['Templates']['ItemBegin'] 		= "<li>\n";
		$mYBitSkins['Templates']['ThumbailOnClick']	= $mYBitSkins['Preview']['JavaScript']."('%window-name%','".$mYBitSkins['Preview']['Width']."','".$mYBitSkins['Preview']['Height']."');";
		$mYBitSkins['Templates']['Preview'] 		= "<a href=\"%preview-url%\" target=\"%window-name%\" onclick=\"%thumbail-on-click%\"><img src=\"".$mYBitSkins['Pictures']['PreviewIcon']."\" align=\"absmiddle\" border=\"0\" title=\"".$mYBitSkins['Titles']['ClickToShowPreview']."\" vspace=\"1\" /></a>\n";
		$mYBitSkins['Templates']['NoPreview'] 		= "";
		$mYBitSkins['Templates']['Icon'] 			= "<img src=\"%icon-url%\" align=\"absmiddle\" border=\"0\" title=\"%icon-title%\" vspace=\"1\" />\n";
		$mYBitSkins['Templates']['ItemBody'] 		= "<a href=\"%download-url%\" title=\"%download-title%\">%icon-tpl%</a>\n <sup>%preview-tpl%</sup>\n <a href=\"%download-url%\" title=\"%download-title%\">%display-name%</a>\n";
		$mYBitSkins['Templates']['ItemEnd'] 		= "</li>\n";
		$mYBitSkins['Templates']['NewItemsGroup'] 	= "</ul></td>\n<td align=\"left\" valign=\"top\">\n<ul style=\"list-style-type: none\">\n";
		$mYBitSkins['Templates']['End'] 			= "</ul>\n</td>\n</tr>\n</table>";
		}
	else
		{
		$mYBitSkins['Templates']['Begin'] 			= "<center><table width=\"95%\">\n<tr>\n";
		$mYBitSkins['Templates']['ItemBegin'] 		= "<td align=\"center\">\n";
		$mYBitSkins['Templates']['ThumbailOnClick']	= $mYBitSkins['Preview']['JavaScript']."('%window-name%','".$mYBitSkins['Preview']['Width']."','".$mYBitSkins['Preview']['Height']."');";
		$mYBitSkins['Templates']['Preview'] 		= "<a href=\"%preview-url%\" target=\"%window-name%\" onclick=\"%thumbail-on-click%\"><img width=\"".$mYBitSkins['Thumbails']['Width']."\" height=\"".$mYBitSkins['Thumbails']['Height']."\" lowsrc=\"".$mYBitSkins['Pictures']['NoPreview']."\" src=\"%thumbail-url%\" border=\"0\" title=\"".$mYBitSkins['Titles']['ClickToShowPreview']."\" align=\"texttop\" vspace=\"1\" /></a>\n";
		$mYBitSkins['Templates']['NoPreview'] 		= "<img width=\"".$mYBitSkins['Thumbails']['Width']."\" height=\"".$mYBitSkins['Thumbails']['Height']."\" src=\"".$mYBitSkins['Pictures']['NoPreview']."\" border=\"0\" title=\"".$mYBitSkins['Titles']['NoPreviewAvailable']."\" align=\"texttop\" vspace=\"1\" />\n";
		$mYBitSkins['Templates']['Icon'] 			= "<img src=\"%icon-url%\" align=\"absmiddle\" border=\"0\" title=\"%icon-title%\" />\n";
		$mYBitSkins['Templates']['ItemBody'] 		= "%preview-tpl%<br />\n<a href=\"%download-url%\" title=\"%download-title%\">%display-name%</a>\n <a href=\"%download-url%\">%icon-tpl%</a>\n";
		$mYBitSkins['Templates']['ItemEnd'] 		= "</td>\n";
		$mYBitSkins['Templates']['NewItemsGroup'] 	= "</tr>\n<tr>\n";
		$mYBitSkins['Templates']['End'] 			= "</tr>\n</table></center>\n";
		}
	}
	
function mYBS_SetPopUpScript($Width=326,$Height=186)
	{
	//Configuration de mYBitSkins
	global $mYBitSkins;
	
	$mYBitSkins['Preview']['JavaScript'] 		= "mYBSPopUp";
	$mYBitSkins['Preview']['Width'] 			= $Width;
	$mYBitSkins['Preview']['Height'] 			= $Height;

	echo("<script type=\"text/javascript\" language=\"JavaScript\">");
	echo("function mYBSPopUp(WindowName,WindowWidth,WindowHeight)");
	echo("{");
	echo("mYBSPopUpWindow=open('',WindowName,\"hotkeys=no,personalbar=no,toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,dependent=yes,width=".($Width + 18).",height=".($Height + 30)."\");");
	echo("}");
	echo("</script>");
	}

function mYBS_SetThumbailsSizes($Width=90,$Height=51)
	{
	//Configuration de mYBitSkins
	global $mYBitSkins;
	
	$mYBitSkins['Thumbails']['Width'] 			= $Width;
	$mYBitSkins['Thumbails']['Height'] 			= $Height;
	}
	
function mYBS_SetPicturesURLs($URL='')
	{
	//Configuration de mYBitSkins
	global $mYBitSkins;
	
	$mYBitSkins['Pictures']['URL'] 				= $URL;
	$mYBitSkins['Pictures']['NoPreview'] 		= $mYBitSkins['Pictures']['URL']."/no-preview-ym6.jpg";
	$mYBitSkins['Pictures']['ZipIcon'] 			= $mYBitSkins['Pictures']['URL']."/zip-file-icon.gif";
	$mYBitSkins['Pictures']['YSZIcon'] 			= $mYBitSkins['Pictures']['URL']."/ymp-file-icon.gif";
	$mYBitSkins['Pictures']['YMSIcon'] 			= $mYBitSkins['Pictures']['URL']."/ymp-file-icon.gif";
	$mYBitSkins['Pictures']['PreviewIcon'] 		= $mYBitSkins['Pictures']['URL']."/preview-icon.gif";
	}

function mYBS_Print()
	{
	//Configuration de mYBitSkins
	global $mYBitSkins;
	
	//Debut affichage
	echo($mYBitSkins['Templates']['Begin']);
	$rep = opendir($mYBitSkins['Source']['Path']);
	$numcol = 1;
	while ($file = readdir($rep))
		{
		if($file != '..' && $file !='.' && $file !='')
			{
			//Informations sur le chemin du fichier
			$fileinfos = pathinfo($file);
			
			if (is_dir($file) OR empty($fileinfos['extension']))
				{
				//Dossier ou fichier  ignorer
				}
			else if (($fileinfos['extension'] == "ysz") OR ($fileinfos['extension'] == "zip") OR ($fileinfos['extension'] == "yms"))
				{
				//Nom du fichier sans l'extension
				$fileinfos['filename'] = substr($fileinfos['basename'],0,strlen($fileinfos['basename'])-strlen($fileinfos['extension'])-1);
				//Nom pour affichage
				$fileinfos['displayname'] = mYBS_File_NameToDisplay($fileinfos['filename']);
				//Nom pour fentre PopUp
				$fileinfos['windowname'] = str_replace(array('-','_'), "", $fileinfos['filename']);
				//Dbut de la cellule
				echo($mYBitSkins['Templates']['ItemBegin']);
				//Recherche de l'aperu ; Jpg, Jpeg, GIF, ou PNG
				$mYBSPreviewTpl = '';
				if (file_exists($mYBitSkins['Thumbails']['Path']."/".$fileinfos['filename'].".jpg"))
					{
					$fileinfos['previewname'] = $fileinfos['filename'].".jpg";
					}
				else if (file_exists($mYBitSkins['Thumbails']['Path']."/".$fileinfos['filename'].".gif"))
					{
					$fileinfos['previewname'] = $fileinfos['filename'].".gif";
					}
				else if (file_exists($mYBitSkins['Thumbails']['Path']."/".$fileinfos['filename'].".png"))
					{
					$fileinfos['previewname'] = $fileinfos['filename'].".png";
					}
				else if (file_exists($mYBitSkins['Thumbails']['Path']."/".$fileinfos['filename'].".jpeg"))
					{
					$fileinfos['previewname'] = $fileinfos['filename'].".jpeg";
					}
				else
					{
					//Pas d'aperu
					$fileinfos['previewname'] = '';
					}
				//Code pour l'aperu
				if ($fileinfos['previewname'])
					{
					//Evenement OnClick
					$mYBSThumbailOnClickTpl = str_replace(	array('%window-name%'),
															array($fileinfos['windowname']),
															$mYBitSkins['Templates']['ThumbailOnClick']);
					//Miniature et aperu
					$mYBSPreviewTpl = str_replace(	array('%thumbail-width%','%thumbail-height%','%no-preview-picture%','%preview-url%','%window-name%','%thumbail-on-click%','%thumbail-url%'),
													array($mYBitSkins['Thumbails']['Width'],$mYBitSkins['Thumbails']['Height'],$mYBitSkins['Pictures']['NoPreview'],$mYBitSkins['Preview']['URL'].$fileinfos['previewname'],$fileinfos['windowname'],$mYBSThumbailOnClickTpl,$mYBitSkins['Thumbails']['URL']."/".$fileinfos['previewname']),
													$mYBitSkins['Templates']['Preview']);
					}
				else
					{
					$mYBSThumbailOnClickTpl = '';
					$mYBSPreviewTpl = str_replace(	array('%thumbail-width%','%thumbail-height%','%no-preview-picture%','%no-preview-title%'),
													array($mYBitSkins['Thumbails']['Width'],$mYBitSkins['Thumbails']['Height'],$mYBitSkins['Pictures']['NoPreview'],$mYBitSkins['Titles']['NoPreviewAvailable']),
													$mYBitSkins['Templates']['NoPreview']);
					}
				//Type d'icone
				$mYBSIconTpl = '';
				if ($fileinfos['extension'] == "ysz")
					{
					$mYBSIconTpl = str_replace(	array('%icon-url%','%icon-title%'),
												array($mYBitSkins['Pictures']['YSZIcon'],$mYBitSkins['Titles']['YSZFile']),
												$mYBitSkins['Templates']['Icon']);
					}
				else if ($fileinfos['extension'] == "zip")
					{
					$mYBSIconTpl = str_replace(	array('%icon-url%','%icon-title%'),
												array($mYBitSkins['Pictures']['ZipIcon'],$mYBitSkins['Titles']['ZipFile']),
												$mYBitSkins['Templates']['Icon']);
					}
				else if ($fileinfos['extension'] == "yms")
					{
					$mYBSIconTpl = str_replace(	array('%icon-url%','%icon-title%'),
												array($mYBitSkins['Pictures']['YMSIcon'],$mYBitSkins['Titles']['YMSFile']),
												$mYBitSkins['Templates']['Icon']);
					}
				//Corps de la cellule
				$mYBSItemTpl = str_replace(	array('%preview-tpl%','%download-url%','%download-title%','%display-name%','%icon-tpl%'),
											array($mYBSPreviewTpl,$mYBitSkins['Settings']['DownloadURL'].$fileinfos['basename'],$mYBitSkins['Titles']['ClickToDownload'],$fileinfos['displayname'],$mYBSIconTpl),
											$mYBitSkins['Templates']['ItemBody']);
				echo($mYBSItemTpl);
				//Fin de cellule
				echo($mYBitSkins['Templates']['ItemEnd']);
				//Test si nouvelle ligne
				if ($numcol == $mYBitSkins['Settings']['ItemsByGroup'])
					{
					$numcol = 1;
					echo($mYBitSkins['Templates']['NewItemsGroup']);
					}
				else
					{
					$numcol++;
					}
				}
			}
		}
	closedir($rep);
	clearstatcache();
	echo($mYBitSkins['Templates']['End']);
	//Fin affichage
	}
	
function mYBS_File_NameToDisplay($filename)
	{
	$displayname = str_replace(array('-','_'), " ", $filename);
	$displaynamewords = explode(" ",$displayname);
	foreach ($displaynamewords as $key => $value)
		{
		$displaynamewords[$key] = ucfirst($value);
		}
	$displayname = implode(" ",$displaynamewords);
	
	return $displayname;
	}
	
function mYBS_Zip_ExtractPreview($zipfilename)
	{
	//MARCHE PO :o((((((
	if (function_exists("zip_open"))
		{
		$zip  = zip_open($mYBitSkins['Source']['Path']."/".$zipfilename);
		if ($zip)
			{
			echo("1");
		   	zip_close($zip);
			}
		else
			{
			echo("0");
			}
		} 
	}
	

?>
